#!/usr/local/bin/wish4.1 -f



set news(TkNews,geo) 446x384+21+65
set news(setup,geo) 689x551
set news(post,geo) 689x551
set news(mail,geo) 689x551
set news(readart,geo) 700x600+21+65
set news(readgrp,geo) 991x390+21+65
set news(dnload,geo) 246x484+21+65
set news(decode,geo) 400x60

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# normal motif style pasting

bind Entry <Button-2> {catch {%W insert insert [selection get]}}

bind Entry <Double-Button-1> {%W select from 0 ; %W select to end}

bind Entry <Delete> {handle_backspace %W}
bind Entry <BackSpace> {handle_backspace %W}
bind Entry <Control-h> {handle_backspace %W}

proc handle_backspace w {
    if {[catch {$w delete sel.first sel.last}]} {
        set pos [expr [$w index insert]-1]
        $w delete $pos 
    }
}






proc lstrmall { win } {
	global news

	foreach idx $news($win,sel) {
		$win.seq delete $idx
		$win.seq insert $idx ""
	}
	set news($win,sel) ""
}

proc scroll { win args} {
	eval $win.x    yview $args
	eval $win.main yview $args
	eval $win.seq  yview $args
}
	
proc setseq { win y } {
	global news

	set idx [$win.main nearest $y]

	if { [llength $news($win,sel)] == 0 } {
		foreach i [$win.main curselection] {
			lappend news($win,sel) $i
			set n [llength $news($win,sel)]
			$win.seq delete $i
			$win.seq insert $i $n
		}
	}

	if { [$win.main selection includes $idx] } {
		set lidx [lsearch $news($win,sel) $idx]
		set news($win,sel) [lreplace $news($win,sel) $lidx $lidx]
		$win.seq delete $idx
		$win.seq insert $idx ""
		set count 0
		foreach idx $news($win,sel) {
			incr count
			$win.seq delete $idx
			$win.seq insert $idx $count
		}
	} else {
		lappend news($win,sel) $idx
		set n [llength $news($win,sel)]
		$win.seq delete $idx
		$win.seq insert $idx $n
	}	
}

proc search_txt { w } {
	global news 

	if { ![info exists news($w,search_idx)] } {
		set news($w,search_idx) 1.0
	}

if { $news($w,mask) != "" } {
	set sz 0
	$w.main tag remove sel 1.0 end
	set idx [$w.main search -regexp -count len $news($w,mask) $news($w,search_idx)]
	if { $idx != "" } {
		set news($w,search_idx) "$idx +1 chars"
		$w.main tag add sel $idx "$idx + $len chars"
		$w.main see $idx
	} else { 
		tk_dialog .sme "TkNews" "$news($w,mask) Not found!" info 0 OK
	}
}
}

proc window { win geo title type args } {
	global news

wm withdraw .
catch "destroy $win"

toplevel $win 
wm title $win "$title"
wm minsize $win 10 10


#  This frame is availible for calling functions to add additional widgets
frame $win.uf -relief flat
pack $win.uf -expand 0 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

#
#   Create a uttons
frame $win.bf  -relief flat
pack $win.bf -in $win -anchor nw -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

# Create the buttons

foreach bt $args {
	set b [string tolower $bt ]
button $win.$b -text $bt
pack $win.$b -in $win.bf -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
}




frame $win.f1 -borderwidth 2 -relief raised 
pack $win.f1 -in $win -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4 -borderwidth 2 -relief raised 
pack $win.f1.f4 -in $win.f1 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4.f3 -borderwidth 2 -relief raised -width 50
pack $win.f1.f4.f3 -in $win.f1.f4 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f4.f3.f17 -width 50
pack $win.f1.f4.f3.f17 -in $win.f1.f4.f3 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

if { $type == "text" } {
	$type $win.main  -wrap none -height 1 -width 1 -relief sunken -xscrollcommand "$win.f1.f4.f3.sb20 set" -yscrollcommand "$win.f1.f4.f3.f17.sb13 set"
	pack $win.main -in $win.f1.f4.f3.f17 -expand 1 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side left
	scrollbar $win.f1.f4.f3.f17.sb13  -command "$win.main yview" 
} else {
	frame $win.lf   -relief sunken -borderwidth 2
	$type $win.x    -height 1 -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat 
	$type $win.seq  -height 1 -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat 
	$type $win.main -height 1 -width 1 -font -*-fixed-bold-r-normal--13-* -relief flat -xscrollcommand "$win.f1.f4.f3.sb20 set" -yscrollcommand "$win.f1.f4.f3.f17.sb13 set"
	$win.main configure -selectmode extended
	bind $win.main <1> "lstrmall $win "
	bind $win.main <Control-Button-1> "setseq $win %y "

	pack $win.lf   -in $win.f1.f4.f3.f17 -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.x    -in $win.lf           -anchor w -expand 0 -fill y    -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.main -in $win.lf           -anchor w -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	pack $win.seq  -in $win.lf           -anchor w -expand 0 -fill y    -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	scrollbar $win.f1.f4.f3.f17.sb13  -command "scroll $win" 
}
set news($win,sel) ""




pack $win.f1.f4.f3.f17.sb13 -in $win.f1.f4.f3.f17 -anchor center -expand 0 -fill y -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right

frame $win.f1.f4.f3.f19 -width 15
pack $win.f1.f4.f3.f19 -in $win.f1.f4.f3 -anchor se -expand 0 -fill none -ipadx 0 -ipady 0 -padx 5 -pady 5 -side right

scrollbar $win.f1.f4.f3.sb20 -command "$win.main xview" -orient horizontal
pack $win.f1.f4.f3.sb20 -in $win.f1.f4.f3 -anchor center -expand 0 -fill both -ipadx 0 -ipady 0 -padx 5 -pady 5 -side bottom


frame $win.f1.f5
pack $win.f1.f5 -in $win.f1 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

label $win.f1.f5.l -text "Mask: "
pack $win.f1.f5.l -expand 0 -fill x -side left
entry $win.f1.f5.e -textvariable news($win,mask)
pack $win.f1.f5.e -expand 1 -fill x -side left

if { $type == "text" } {
	button $win.f1.f5.b -text Serch -command "search_txt $win"
} else {
	button $win.f1.f5.b -text Serch -command "search_grp $win"
}
pack $win.f1.f5.b -expand 0 -fill x -side left


frame $win.f1.f6 -borderwidth 2 -relief raised -width 50
pack $win.f1.f6 -in $win.f1 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f6.f13 -borderwidth 2 -relief sunken -width 50
pack $win.f1.f6.f13 -in $win.f1.f6 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

label $win.f1.f6.f13.l17 -text TkNews -textvariable news($win,l1)
pack $win.f1.f6.f13.l17 -in $win.f1.f6.f13 -anchor center -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

frame $win.f1.f6.f14 -borderwidth 2 -width 50
pack $win.f1.f6.f14 -in $win.f1.f6 -anchor center -expand 1 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

message $win.f1.f6.f14.mg19 -borderwidth 0 -padx 5 -pady 2 -textvariable news($win,message)  -width 400
pack $win.f1.f6.f14.mg19 -in $win.f1.f6.f14 -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

scale $win.scale -from 1 -to 100 -variable news($win,scale)  -showvalue true \
	-orient horizontal -state disabled 

frame $win.f1.f6.f15  -borderwidth 2 -relief sunken -width 50
pack $win.f1.f6.f15 -in $win.f1.f6 -anchor center -expand 0 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side right

label $win.f1.f6.f15.l21 -text TkNews -textvariable news($win,l2)
pack $win.f1.f6.f15.l21 -in $win.f1.f6.f15 -anchor center -expand 1 -fill none -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
set  news($win,mask) ""
set  news($win,l1) $title
set  news($win,l2) $title
set  news($win,stop) 0
set  news($win,scale) 0

if { [info exists news($geo,geo)] } {
	wm geometry $win $news($geo,geo)
	bind $win <Configure> "setgeo $win %W $geo"
}

	return $win
}

proc setgeo { w1 w2 geo } {
	global news

	if { $w1 == $w2 } {
		set news($geo,geo) [wm geometry $w1]
	}
}

proc setmsg { win } {
	global news

	pack forget  $win.scale
	pack $win.f1.f6.f14.mg19 -in $win.f1.f6.f14 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
}

proc setscale { win args } {
	global news

	set n [llength $args]

	set from 1
	set to 100
	if { $n > 0 } {	
 	switch [llength $args] {
		1 { set to [lindex $args 0];set from 1 }
		2 { set from [lindex $args 0]; set to [lindex $args 1] }
		}
	}

	$win.scale configure -from $from -to $to -label $news($win,message)
	pack forget  $win.f1.f6.f14.mg19 
	pack $win.scale -in $win.f1.f6.f14 -anchor center -expand 1 -fill both -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
}





#  Get the header for a news article, return a list
#
proc getheader { a sock} {
	global news


	if { $news(xover) == 0 } {
		socksend $sock "head $a\n"
		set res [getresp $sock]
		if { [rescode $res 221] } {
			return ""
		}
		set path [getresp $sock]
		set rfrom [getresp $sock]
		set newsgrps [getresp $sock]
		set subj [getresp $sock]
		set sl [string length $subj]
		set subj [string range $subj 9 $sl]
		set date [getresp $sock]
		set organization [getresp $sock]
		set lines [getresp $sock]
		set lines [string range $lines 6 end]
	} else {
		socksend $sock "xover $a\n"
		set res [getresp $sock]
		if { [rescode $res 224] } {
			closewin $w
			return ""
		}
		set res [getresp $sock]
		set l [split $res "\t"]
		set subj [lindex $l 1]
		set rfrom [lindex $l 2]
		set date [lindex $l 3]
		set lines [lindex $l 7]
	}
		while { $res != "." } {
			set res [getresp $sock]
		}

		set from [lindex [split $rfrom "(" ] 1]
		set from [lindex [split $from ")" ] 0]
		if { $from == "" } {
			set from [lindex [split $rfrom ] 1]
		}

		return  [list $a $from $subj $date $lines]
}
			
proc saveart { w } {
	global news

	#  For the time being I am assuming that xfm.tcl is in the current
	#  Directory  Or in the path
	set fn [exec $news(wish) -f xfm.tcl $news(filename)]
	if { $fn == "" } { return }
	set news(filename) $fn
	set om "w"

	if { [file exists $fn]  } {
		set res [tk_dialog .xxme "TkNews" "$fn already exists!" question 0 Append Overwrite Cancel]
		switch $res {
			0 { set om "a" }
			1 { set om "w" }
			2 { return }
		}
	}
	set f [open $fn $om]

	#  Save from text widget
	puts $f [$w.main get 1.0 end]
	close $f
}

proc catchup { g {w ""} } {
	global news newsread newsunread

	foreach a [array names newsunread $g,*] {
		set newsread($a) $newsunread($a)
		unset newsunread($a)
	}
	if { $w != "" } {
		$w.done invoke 
	}
	count_group $g
	if { $news(showall) == 0 } {
		refilter
	}
}


proc sortgrp { a b } {
	global news	

	switch $news(sort) {
		Subject { set idx 2 }
		Date    { set idx 3 }
		Auther { set idx 4 }
		default { puts "Error::  Invalid sort spec $news(sort)" }
		}

	set a1 [lindex $a $idx]
	set b1 [lindex $b $idx]
	
	#  I want replys to follow the original article
	#  so I remove the "Re:" and append a "1"
	if { $idx == 2 } {
		if { [string range $a1 0 3] == "Re: " } {
			set a1 "[string range $a1 4 end] 1"
		}
		if { [string range $b1 0 3] == "Re: " } {
			set b1 "[string range $b1 4 end] 1"
		}
	}
	return [string compare $a1 $b1]
}

proc rescode { res code {msg ""} } {

	set val [string range $res 0 2]
	if { $val != $code } {
		if { $msg == "" } {
			set msg "Bad return code!\nExpected $code got $res"
		}
		set ok [tk_dialog .xxerr "TkNews"  $msg error 0 OK
		return 1
	} else {
		return 0
	}
}

proc connectit { } {
	global news 


	set ts "[lindex [split [gmtime]] 1]"
	if { $news(main) != "" && ![info exists news(main,proc)] } {
		set news(main,proc) $ts
		update
		if { $news(main,proc) == $ts } {
			return $news(main)
		}
	}
 
	set sock [socket]
	connect $sock $news(serv) nntp

	# Check for a good connection
	set res [getresp $sock]
	set val [string range $res 0 2]
	if { $val != "200" } {
		disconnect $sock
		tk_dialog .xxerr "TkNews" \
			"Can't create another connection to $news(serv)!\nReceived ($res)." question 0 OK 
			return ""
	}
	if { ![info exists news(xover)] } {
		socksend $sock "xover 111\n"
		set resp [getresp $sock]
		set val [string range $resp 0 2]

		# 412 not in news group if supported
		if { $val == "412" } {
			set news(xover) 1
		} else {
			set news(xover) 0
		}
	}
	if { $news(main) == "" } {
		set news(main,proc) $ts
		update
		if { $news(main,proc) == $ts } {
			set news(main) $sock
		}
	}
	return $sock
}

proc disconnect sock {
	global news

	if { $news(main) == $sock } {
		catch [unset news(main,proc)] msg
		return
	}
	closesocket $sock
}

proc saveConfig {savecode} {
	global news sgroups newsread

	
	set news(lst_date) [gmtime] ; #  This is in tclsock.[dll/so]

	if { $savecode == 1 } {
	set fd [open $news(home)/tknews.geo w]
	foreach g [array names news *,geo] {
		puts $fd "set news($g) $news($g)"
	}
	close $fd
	set fd [open $news(home)/tknews.rc w]
		puts $fd $news(name)
		puts $fd $news(serv)
		puts $fd $news(mail)
		puts $fd $news(email)
		puts $fd $news(lst_date)
		puts $fd $news(sort)
		puts $fd $news(con_on_start)
		puts $fd $news(newgrps)
		puts $fd $news(saveonexit)
		close $fd
	}

	set fd [open $news(home)/tknews.sig w]
	puts $fd $news(sig)  
	close $fd

	set fd [open $news(home)/sgroups.dat w]
	# This is the last date
	# that tknews save a status
	# Last time new groups were
	# requested
	puts  $fd $news(grp_date)

	foreach g [array names sgroups] {
		set l ""
		foreach a [array names newsread $g,*] {
			lappend l $newsread($a)
		}
		puts $fd "$g $sgroups($g) [lsort $l]"
	}
	close $fd
}

proc inslst { w1 g order } {
	global news sgroups


	set w "$w1.main"
	set max_idx [$w size]

if { [ string match "*$news($w1,mask)*" $g] == 1 } {
		if { [info exists sgroups($g)] } {
			set flag "X"
		} else {
			set flag ""
		}
if { [info exists news($g,count)]  } {
	set count $news($g,count)
} else {
	set count ""
}

set g "$g ($count)"
if { $order == 1 } {
             set n [string tolower $g]
      for { set idx 0 } { $idx < $max_idx } { incr idx } {
		set l2 [$news(glst) get $idx]
		set l [lindex [split $l2] 0]
                if { $l == $n } {
                        $w delete $idx
                        $w insert $idx $g
                        $w1.x delete $idx
                        $w1.x insert $idx $flag
			
                        return 1
                }
                if { [string compare $l $n] > 0 } {
                        $w insert $idx $g
			$w1.seq insert $idx ""
			$w1.x   insert $idx $flag
                        return 1
                }
        }
}
	$w insert end $g
	$w1.seq insert end ""
	$w1.x   insert end $flag
	return 1
} else { 
	return 0
}
}


proc getnewgroups {} {
	global news groups sgroups ngroups

	if { ![file exists $news(home)/groups.dat] } {
		return [getallgroups]
	}

	socksend $news(main) "newgroups $news(grp_date) GMT\n"
	set res ""
	while { $res == "" } {
		set res [recv $news(main)]
		set val [string range $res 0 2]
	}

	if { $val != 231 } {
		tk_dialog .nd "TkNews" \
			"Can't get newgroups ($res)" \
			error 0 OK CANCEL] == 0 
		return
	   }

	set news(.news,message) "Reading new groups since $news(grp_date)"
	set fd [open $news(home)/groups.dat a] 
	set news(.news,l1) 0
	set count 0
	while { $res != "." } {
		set res [recv $news(main)] 
			
		# This will certainly couse problems.  
		# Might be better to close and reopen the connections.
		if { $news(.news,stop) == 1 } { 
			close $fd
			set news(grp_date) [gmtime] 
			set news(.news,message) "Operation Terminated"
			return 
		} 
				
		if { $res != "" && $res != "." } {
			set lst [split $res]
			set g [lindex $lst 0 ]
			set y [lindex $lst 3 ]
			set groups($g) $y
			inslst .news $g 0
			puts $fd "$g $y"
			incr count
		}
		if { $count >= 30 } {
			incr news(.news,l1)  $count
			set count 0
			update
		}
	}
	close $fd
	set news(grp_date) [gmtime] ; # tclsock.so
	set news(.news,message) "Operation Complete"
	return
}


proc getallgroups {} {
	global news groups sgroups


	if { ![file exists $news(home)/groups.dat] } {
		if { $news(main) != "" && [tk_dialog .nd "TkNews" "Availible news groups are not known.\n Downloading them will take some time.\nWould you like to download them now?" question 0 OK CANCEL] == 0 } {
			socksend $news(main) "list active\n"
			set res ""
			while { $res == "" } {
				set res [recv $news(main)]
				set val [string range $res 0 2]
			}
		
		   if { $val != 215 } {
			tk_dialog .nd "TkNews" \
				"Can't get groups ($res)" \
				error 0 OK CANCEL] == 0 
			return
		   }

		set news(.news,message) "Reading all active news groups From server"
			set fd [open $news(home)/groups.dat w] 
			set news(.news,l1) 0
			set count 0
			set news(showall) 1
			while { $res != "." } {
				set res [recv $news(main)] 
			
				# This will certainly couse problems.  
				# Might be better to close and reopen the connections.
				if { $news(.news,stop) == 1 } { 
					close $fd
					set news(grp_date) [gmtime] 
					set news(.news,message) "Operation Terminated"
					return 
				} 
				
				if { $res != "" && $res != "." } {
					set lst [split $res]
					set g [lindex $lst 0 ]
					set y [lindex $lst 3 ]
					set groups($g) $y
					inslst .news $g 0
					puts $fd "$g $y"
					incr count
				}
				if { $count >= 30 } {
					incr news(.news,l1)  $count
					set count 0
					update
				}
			}
			close $fd
			set news(grp_date) [gmtime] ; # tclsock.so
			set news(.news,message) "Operation Complete"
			return
		}
	} else {
		set news(.news,message) "Reading all active news groups From $news(home)/groups.dat"
		set fd [open $news(home)/groups.dat r]
		set news(.news,l1) 0
		set count 0
		set news(showall) 1
		while { [gets $fd line] > 0 && $news(.news,l1) < 100000 } {
			set l [split $line]
			set g [lindex $l 0]
			set y [lindex $l 1]
			set groups($g) $y
			inslst .news $g 0
			incr count
			if { $count >= 30 } {
				incr news(.news,l1) $count
				set count 0
				update
			}
		}
		close $fd
		incr news(.news,l1) $count
		set news(.news,message) "Operation Complete"
	}
}


proc unsubscribe {} {
	global news groups sgroups

	foreach idx [$news(glst) curselection] {
		set l [$news(glst) get $idx]
		set g [lindex [split $l] 0]
		unset sgroups($g) 
		.news.x delete $idx 
		.news.x insert $idx ""
	}
	$news(glst) selection clear 0 end
}

proc subscribe_to {} {
	global news groups sgroups

	foreach idx [$news(glst) curselection] {
		set l [$news(glst) get $idx]
		set g [lindex [split $l] 0]
		set sgroups($g) $groups($g)
		.news.x delete $idx 
		.news.x insert $idx "X"
	}
	$news(glst) selection clear 0 end
}

proc getresp { sock {db ""} } {

	set res ""
	
	set count 0

	set res1 [recv $sock]
#	set res2 [recv $sock]

#	if { $res2 != "" } {
#		puts "Error res2 == ($res2) in getresp"
#	}
	return $res1
	
}

proc closewin { ts } {
	global news

	set w ".$ts"
	destroy $w
	foreach a [array names news $ts*] {
		unset news($a)
	}
	foreach a [array names news $w*] {
		unset news($a)
	}

}

proc leave {savecd } {
	global news

	if { $savecd == 1 } {
		saveConfig $news(saveonexit)
	}
	if { $news(main) != "" } {
		socksend $news(main) "quit\n";
		closesocket $news(main)
	}
	exit 0
}

proc readart { g ts } {
	global news  newsread  newsunread

	set w1 ".$ts.main"
	set wx ".$ts.x"

foreach idx [$w1 curselection] {
	set l1 [$w1 get $idx]


	set a [lindex [split $l1] 0]
	#  Get a time stamp for the Window name
	set nts "[lindex [split [gmtime]] 1]"
	set w ".$nts"
	set txt "G$nts"
	window $w readart $txt text Done Mail Reply Save 
	wm title $w "$l1"
	#  Get a seperate connection for this window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		destroy $w
		return
	}

	set news($w,stop) 0
	$w.done configure -command "closewin $nts"
	$w.mail configure -command "mailart $w.main $g"
	$w.reply configure -command "post $g $w.main"
	$w.save configure -command "saveart $w"

	#  Configure the header area

	socksend $news($nts) "group $g\n"
	if { [rescode [getresp $news($nts)] 211] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	socksend $news($nts) "article $a\n"
	if { [rescode [getresp $news($nts)] 220] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	set count 0
	set news($w,message) "Getting article"
	set news($w,l1) 0
	update
	set res [getresp $news($nts)]
	while { $res != "." } {
		incr count
		if { $count > 5 } {
			incr news($w,l1) $count
			update
			set count 0
		}
		$w.main insert end "$res\n"
		set res [getresp $news($nts)]
	}	
	disconnect $news($nts);

	bind $w.main <Key> {}
	if { [$wx get $idx] != "X" } {
		incr news($g,count) -1
	}
	$wx insert $idx "X"
	incr idx
	$wx delete $idx
	set newsread($g,$a)  $a
	if { [info exists newsunread($g,$a)] } {
		catch [unset newsunread($g,$a)] msg
	}
	set news($w,message) ""
	if { $news(showall) == 0 } {
		refilter
	}
}
}

proc dnsave { wo g } {
	global news  newsread 

	set w1 "$wo.main"
	set wx "$wo.x"
	set fn [exec $news(wish) -f xfm.tcl $news(filename)]
	if { $fn == "" } { return }
	set news(filename) $fn
	set om "w"

	if { [file exists $fn]  } {
		set res [tk_dialog .xxme "TkNews" "$fn already exists!" question 0 Append Overwrite Cancel]
		switch $res {
			0 { set om "a" }
			1 { set om "w" }
			2 { return }
		}
	}
	set fd [open $fn $om]

	#  Get a time stamp for the Window name
	set nts "[lindex [split [gmtime]] 1]"
	set w ".$nts"
	set txt "G$nts"
	toplevel $w
	wm geometry $w $news(dnload,geo)
	bind $win <Configure> "setgeo $w %W dnload"

	#  Get a seperate connection for this Window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		destroy $w
		return
	}

	#  Configure the header area

	socksend $news($nts) "group $g\n"
	if { [rescode [getresp $news($nts)] 211] } {
		closewin $nts
		disconnect $news($nts);
		return
	}

	scale $w.s -from 1 -to 100  -variable news($w,scale)  -label "Fetching Article"\
		-showvalue true -orient horizontal -length 400 -state disabled
	pack $w.s

# If multiple files are saved they will go to the same file
# foreach idx [$w1 curselection] 
foreach idx [ordered $wo ] {
	set l1 [$w1 get $idx]

	wm title $w "$l1"

	set a [lindex [split $l1] 0]
	set news($w,scale)   0
	set count 0

	#  Get the header to determine the number of lines
	set l [getheader $a $news($nts)]
	set lines [lindex $l 4]
	$w.s configure -to $lines -label "Fetching Article ($lines lines)"
	socksend $news($nts) "article $a\n"
	if { [rescode [getresp $news($nts)] 220] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	update
	
	set res [getresp $news($nts)]
	while { $res != "." } {
		incr count
		if { $count > 5 } {
			incr news($w,scale) $count
			set count 0
			update
		}
		puts $fd $res
		set res [getresp $news($nts)]
	}	
	set newsread($g,$a) $a
	$wx delete $idx
	$wx insert $idx "X"
	}
	disconnect $news($nts);
	close $fd
	closewin $nts
}

proc ordered { win } {
	global news

	set ret ""

	if { [llength $news($win,sel)] == 0 } {
		foreach i [$win.main curselection] {
			lappend  ret $i
		}
	} else {
		set ret $news($win,sel)
	}
	return $ret
}

proc dndecode { wo g } {
	global news  newsread 

	set w1 "$wo.main"
	set wx "$wo.x"

	# Use tmp file to download
	set fn "[lindex [split [gmtime]] 1].tmp"
	set om "w"

	set fd [open $fn $om]

	#  Get a time stamp for the Window name
	set nts "[lindex [split [gmtime]] 1]"
	set w ".$nts"
	set txt "G$nts"
	toplevel $w
	wm title $w "Decode"
	wm geometry $w $news(decode,geo)
	bind $w <Configure> "setgeo $w %W decode"

	set news($w,scale)   0
	set count 0
	scale $w.s -from 1 -to 100  -variable news($w,scale)  -label "Fetching Article"\
		-showvalue true -orient horizontal -length 400 -state disabled
	pack $w.s

	update
	#  Get a seperate connection for this Window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		closewin $w
		return
	}

	#  Configure the header area

	socksend $news($nts) "group $g\n"
	if { [rescode [getresp $news($nts)] 211] } {
		closewin $nts
		disconnect $news($nts);
		return
	}

	set od [ordered $wo];
	set need [llength $od]
	set fcount 0
	set totlines 0

	foreach idx $od {

		incr fcount
		set l1 [$w1 get $idx]
		set a [lindex [split $l1] 0]
	
		#  Get the header to determine the number of lines
		set l [getheader $a $news($nts)]
		set lines [lindex $l 4]
		set news($w,scale) 0
		$w.s configure -to $lines \
			-label "Saving $fcount/$need ($lines lines)"
		update
	
		socksend $news($nts) "body $a\n"
		if { [rescode [getresp $news($nts)] 222] } {
			closewin $nts
			disconnect $news($nts);
			return
		}
		update
		
		set res [getresp $news($nts)]
		set count 1
		while { $res != "." } {
			incr count
			if { $count > 5 } {
				incr news($w,scale) $count
				incr totlines
				set count 0
				update
			}
			set res [string trim $res " "]
			if { $res != "" } {
				puts $fd $res
			}
			set res [getresp $news($nts)]
		}	
		set newsread($g,$a) $a
		catch [$wx delete $idx]
		catch [$wx insert $idx "X"]
	}

	close $fd
	disconnect $news($nts);

	$w.s configure -to $totlines -label "filtering "
	update
	set fd [open $fn r ]
	set fn2 "[lindex [split [gmtime]] 1].tmp"
	set fd2 [open $fn2 w ]
	set st 0


	#Filter BEGIN and END (note letters)
	set filter 0
	set lcount 0
	while { [gets $fd line] > 0 } {
		incr lcount
		switch $st {
		0 { 
			set bg [string range $line 0 5]
			if { [string compare $bg "BEGIN "] == 0 } {
				set st 1 ; # Looking for END
				incr filter
			} 
		  }
		1 {
			if { $line == "END" } {
				set st 0
				set lcount 0
			} else {
				puts $fd2 $line
			}
		   }
		default {
			puts stderr "Logic error"
			}
		}
	}
	close $fd
	close $fd2

	set news($w,message) "Decoding ..."
	update
	if { $filter == 0 } {
		if [catch {uudecode $fn} dnlst]  {
			set res 1
		} else {
			set res 0
		}
	} else {
		if { [catch {uudecode $fn2} dnlst] } {
			set res 1
		} else {
			set res 0
		}
	}

	if { $res != 0 } {
		tk_dialog .xme "TkNews" "Erorr decoding!\n msg = ($dnlst)" error 0 OK
	} else {
		catch [set news($wo,message) "Decoded $dnlst"]
	}
	update
	exec $news(rm) $fn
	exec $news(rm) $fn2

	closewin $nts
}

proc catchup1 {} {
	global news groups sgroups newsread newsunread order

	foreach idx [$news(glst) curselection] {
		set l1 [$news(glst) get $idx]
		set g [lindex [split $l1] 0]
		set news(.news,message) "Catchup $g"
		update
		catchup $g
	}
}

		
proc read_group {} {
	global news groups sgroups newsread newsunread order

	set news(.news,message) "Go to read news" 
	foreach idx [$news(glst) curselection] {
		set l1 [$news(glst) get $idx]
		set g [lindex [split $l1] 0]
		#  Get a time stamp for the Window name
		set ts "[lindex [split [gmtime]] 1]"
		set w ".$ts"
		set lst "G$ts"
		window $w readgrp $lst listbox Stop Done Save CatchUp UUDecode Post 
		wm title $w "$g"
		set news($w,l1) "Group"
		set news($w,l2) "Group"
		bind $w.main <Double-1> "readart $g $ts"
		
		#  Get a seperate connection for this window
		set news($w,message) "Connecting to server"
		$w.done configure -command "closewin $ts"
		update
		set news($ts)  [connectit]
		set news($w,message) "Reading headers for $g"
		update
		if { $news($ts) == "" } {
			unset news($ts) 
			destroy $w
			return
		}
		set news($w,stop) 0
		$w.stop configure -command "set news($w,stop) 1"
		$w.save configure -command "dnsave $w $g"
		$w.catchup configure -command "catchup $g $w" -text "Catch Up"
		$w.uudecode configure -command "dndecode $w $g"
		$w.post  configure -command "post $g"

		
		socksend $news($ts) "group $g\n"
		set news($w,message) "[getresp $news($ts)] xover($news(xover))"
		set news($g,low) [lindex [split $news($w,message) ] 2]
		set news($g,high) [lindex [split $news($w,message) ] 3]

		if { ![info exists news($g,count)] } {
			if { [count_group $g $news($ts)] == "" } {
				disconnect $news($ts)	
				closewin $ts
				return
			} else { 
				if { $news(showall) == 0 } {
					refilter
				}
			}
		}

		set count 0
		set got   0
		set news($g,order) ""
		set news($w,message) "Fetching Headers"
		setscale $w $news($g,count) 
		set news($w,scale) 0
		update
		foreach a [array names newsunread $g,*] {
			
		if { $news($w,stop) == 0 } {
		if { $news(xover) == 0 } {
			socksend $news($ts) "head $newsunread($a)\n"
			set res [getresp $news($ts)]
			if { [rescode $res 221] } {
				return
			}
			set path [getresp $news($ts)]
			set rfrom [getresp $news($ts)]
			set newsgrps [getresp $news($ts)]
			set subj [getresp $news($ts)]
			set sl [string length $subj]
			set subj [string range $subj 9 $sl]
			set date [getresp $news($ts)]
			set organization [getresp $news($ts)]
			set lines [getresp $news($ts)]
			set lines [string range $lines 6 end]
		} else {
			socksend $news($ts) "xover $newsunread($a)\n"
			set res [getresp $news($ts)]
			if { [rescode $res 224] } {
				closewin $w
				return
			}
			set res [getresp $news($ts)]
			set l [split $res "\t"]
			set subj [lindex $l 1]
			set rfrom [lindex $l 2]
			set date [lindex $l 3]
			set lines [lindex $l 7]
		}
			while { $res != "." } {
				set res [getresp $news($ts)]
			}

			set from [lindex [split $rfrom "(" ] 1]
			set from [lindex [split $from ")" ] 0]
			if { $from == "" } {
				set from [lindex [split $rfrom ] 1]
			}

			set str [list $newsunread($a) $from $subj $date $lines]
			
			# Prepare for sorting
			lappend news($g,order) $str

			incr count 
			if { $count > 5 } {
				incr news($w,scale) $count
				update 
				set count 0
			}
	} else {
		set news($w,stop) 0
	}
			}
		set news($w,message) "Sorting ..."
		setmsg $w
		update
		foreach l [lsort -command sortgrp $news($g,order)] {
			set str   [format "%-8.8s (%-4.4d)  %-20.20s %s" \
				[lindex $l 0] [lindex $l 4] [lindex $l 1] [lindex $l 2] ]
			$w.main insert end $str
			$w.x    insert end ""
			$w.seq  insert end ""
		}
		#$w.main see 1
		set news($w,message) "Process Complete"
		update
		disconnect $news($ts)	
		return
	}
	return
}


#  Read in the configuration file
#  And a list of subscribed news groups
proc loadConfig {} {
	global news sgroups newsread

	if { ![file exists $news(home)/tknews.rc] } {
		set news(sort) Subject
		set news(con_on_start) 0
		set news(newgrps) 1
		tknews_setup
	} else {

		set fd [open $news(home)/tknews.rc r]
		gets $fd news(name)
		gets $fd news(serv)
		gets $fd news(mail)
		gets $fd news(email)
		gets $fd news(lst_date)
		gets $fd news(sort)
		gets $fd news(con_on_start)
		gets $fd news(newgrps)
		gets $fd news(saveonexit)
		close $fd
		set fd [open $news(home)/tknews.sig r]
		set news(sig) ""
		while { [gets $fd line] > 0 } {
			if { $news(sig) == "" } {
				set news(sig) "$line"
			} else {
				set news(sig) "$news(sig)\n$line"
			}
		}
		close $fd
	}

	set news(.news,message) "Reading availible news groups"
	set news(showall) 0
	$news(glst) delete 0 end
	.news.x delete 0 end
	.news.seq delete 0 end
if { ![file exists $news(home)/sgroups.dat] } {
	getallgroups
} else {
	set fd [open $news(home)/sgroups.dat r]
	set news(.news,l1) 0
	set count 0
	gets $fd news(grp_date) ;# Last time new groups were
				 # requested
	while { [gets $fd line] > 0 && $news(.news,stop) == 0 } {
		set l [split $line]
		set g [lindex $l 0]
		set y [lindex $l 1]
		set sgroups($g) $y
		inslst .news $g 1
		incr count
		if { $count >= 30 } {
			incr news(.news,l1) $count
			set count 0
			update
		}
		set max [llength $l]
		for { set i 2 } { $i < $max } { incr i } {
			set a [lindex $l $i]
			if { $a != "" } {
				set newsread($g,$a) $a
			}
		}
	}
	close $fd
}
	set news(.news,stop) 0
	set news(.news,message) ""
}

	#  Count the unread articles in a group
proc count_group { g {s1 ""} } {
		global news newsread newsunread groups sgroups

		if { $s1 == "" } {
			set s [connectit]
			if { $s == "" } {
				return
			}
		} else {
			set s $s1
		}

		socksend $s "group $g\n"
		set res [getresp $s]
		set news($g,low) [lindex [split $res ] 2]
		set news($g,high) [lindex [split $res ] 3]


		# This is just to drop old newsread variables
		foreach a [array names newsread $g,*] {
			if { $newsread($a) < $news($g,low) } {
				unset newsread($a)
			}
		}

		socksend $s "listgroup $g\n"
		set res [getresp $s]
		set val [string range $res 0 2]
		if { $val == 411 } {
			tk_dialog .xxme "TkNews" "Subscribed group $g\nis no longer valid" info 0 OK
			if { [info exists groups($g)] }  {
				unset groups($g)
			}
			if { [info exists sgroups($g)] }  {
				unset sgroups($g)
			}
			foreach v [array names news *$g*] {
				unset news($v)
			}
			if { $s1 == "" } { disconnect $s }
			return ""
		} else {
			if { [rescode $res 211 ] } {
				if { $s1 == "" } { disconnect $s }
				return
			}
		}


		set res [getresp $s]
		set need 0
		while { $res != "." } {
			if { ![info exists newsread($g,$res)] } {
				set newsunread($g,$res) $res
				incr need
			} else {
				if { [info exists newsunread($g,$res)] } {
					unset newsunread($g,$res)
				}
			}
			set res [getresp $s]
		}
	set news($g,count) $need
	if { $s1 == "" } { disconnect $s }
	return $need
}

proc connect_server {} {
	global news sgroups

	set sock [connectit]
	if { $sock == "" } {
		return
	}

	wm title .news "TkNews ($news(serv))"
	update
	if { $news(newgrps) == 1 } {
		getnewgroups
	}
	foreach g [array names sgroups] {
		set news(.news,message) "Subscribing to $g"
		update
		count_group $g $sock
	}
	set news(.news,message) "Connected"
	refilter
}


proc search_grp { w } {
	global news 

	set n [string tolower $news($w,mask)]
	if { $n == "" } {
		tk_dialog .xxmx "TkNews" "Please enter a serch 'Mask' then try again" info 0 OK
		return
	}

	if { ![info exists news($w,search_idx)] } {
		set news($w,search_idx) [$w.main size]
	}

	$w.main selection clear 0 end
	set max [$w.main size]
	set done 0
	set start $news($w,search_idx) 
	if { $start >= $max } {
		set start $max
	}
	set idx [expr $start + 1 ] 
	set $news($w,message) "Serching for $n"
	set $news($w,l1) $idx
	set count 0
	set news($w,l1) 0
	while { $idx != $start } { 
		if { $idx >= $max } {
			set idx  0
		}
		set l [$w.main get $idx]
		if { [ string match "*$n*" $l] == 1 } {
			$w.main selection set $idx
			$w.main see $idx
			$w.x    see $idx
			$w.seq  see $idx
			set news($w,search_idx) $idx
			return
		}
		incr idx
		incr count
		if { $count >= 30 } {
			incr news($w,l1) $count
			set count 0
			update
		}
	}
	tk_dialog .me "TkNews" "$news($w,mask) not found" info 0 OK
}

proc refilter {} {
	global news groups sgroups


	$news(glst) delete 0 end
	.news.x    delete 0 end
	.news.seq  delete 0 end
	if { $news(showall) } {
		if { ![array exists groups] } {
			return [getallgroups]
		}
		set grp groups
	} else {
		set grp sgroups
	}
	set news(.news,message) "Filtering ..."
	update
	set count 0
	set news(.news,l1) 0
	set news(.news,l2) 0
	foreach g [lsort [array names $grp]] {
		if { $news(.news,stop) == 1 } { set news(.news,stop) 0 ; return }
		incr news(.news,l2) [inslst .news $g 0]
		incr count 
		if { $count >= 30 } {
			incr news(.news,l1) $count
			set count 0
			update
		}
	}
	set news(.news,message) "Operation Complete"
	update
}



# Create a form line ,an entry with a lable in a frame
# The frame is NOT packed
proc formline { w l v } {
	global news

	frame $w
	label $w.l -text $l
	pack $w.l -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

	entry $w.e -textvariable $v
	pack $w.e -expand 1 -fill x -side left
	return $w
}

#  Create a form with on entry and label for each arg
proc formwindow { ts geo title args } {
	global news

	set w ".$ts" 
	window $w $geo $title text OK Cancel
	$w.ok configure -command "puts 0"
	$w.cancel configure -command "puts 1"

	set uf $w.uf

	set count 0
	foreach l $args {
		incr count
		set wf [formline $uf.f$count $l news($w,$count) ]
		pack $wf -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top
	}
	return $w
}


proc tknews_setup {} {
	global news

	if { ![info exists news(serv)] } { 
		if { [info exists env(NNTPSERVER)] } {
			set news(serv) $env(NNTPSERVER); # This can override
		} else {
			set news(serv) "news" 
		}
	}

	if { ![info exists news(mail)] } { set news(mail) "mail" }
	if { ![info exists news(email)] } { set news(email) "" }
	if { ![info exists news(home)] } { set news(home) [exec pwd] }
	if { ![info exists news(name)] } { set news(name) "" }
	if { ![info exists news(sig)] } { set news(sig) "Your signature goes here" }

	set ts "[lindex [split [gmtime]] 1]"
	update
	set w [formwindow $ts setup Setup Name "News Server" "Mail Servere" "Email Address" ]
	set news($w,1) $news(name)
	set news($w,2) $news(serv)
	set news($w,3) $news(mail)
	set news($w,4) $news(email)
	$w.ok configure -command "set news($w,wait) 1"
	$w.cancel configure -command "set news($w,wait) 2"
	$w.main insert end $news(sig)
	set news($w,wait) 0

	tkwait variable news($w,wait)
	if { $news($w,wait) == 1 } {
		set news(name)  $news($w,1) 
		set news(serv)  $news($w,2) 
		set news(mail)  $news($w,3) 
		set news(email)  $news($w,4) 
		set news(sig) [$w.main get 1.0 end]
	} 
	closewin $ts
}

#  Post an article to a news group
#  w is only set for a reply
proc post { g {rw ""} } {
	global news


	set date [gmtime]
	set ts "[lindex [split $date] 1]"

	update
	set w [formwindow $ts post "Post to $g"  "From:" "Newsgroups:" "Date:" "Subject:" "Attachment:"]

	set news($w,1) "$news(email) ($news(name))"
	set news($w,2) $g
	set news($w,3) "[string range $date 2 3 ]/[string range $date 4 5 ]/[string range $date 0 1 ]  [string range $date 7 8 ]:[string range $date 9 10 ]:[string range $date 11 12 ] GMT"
	set news($w,4) ""
	set news($w,5) ""
	#  Handle a reply
	set hesaid ""
	if { $rw != "" } {
		set count 1
		set line [$rw get $count.0 $count.end]
		while { $line != "" } {
			set l [split $line : ]
			set hdr [lindex $l 0]
			set bdy [string range $line [expr [string length $hdr] + 1] end] 
			switch $hdr {
				Subject { set news($w,4) [string trim $bdy " "] }
				From    { set from $bdy } 
				Message-ID    { set id $bdy } 
			}
		incr count
		set line [$rw get $count.0 $count.end]
		}
		if { [string compare [string range $news($w,4) 0 2] "Re:"] != 0 } {
			set news($w,4) "Re: $news($w,4)"
		}
		set hesaid [$rw get $count.0 end]
	}
	if { $hesaid != "" } {
		$w.main insert end "in message $id from $g\n$from wrote:\n"
		foreach line [split $hesaid "\n"] {
			$w.main insert end ">$line\n"
		}
	}
	$w.ok configure -command "set news($w,wait) 1"
	$w.cancel configure -command "set news($w,wait) 2"
	bind $w.uf.f5.e  <Tab> "focus $w.main;break"
	focus $w.uf.f4.e 

	set news($w,wait) 0

	tkwait variable news($w,wait)
	if { $news($w,wait) == 1 } {
		set news($ts) [connectit] 

		socksend $news($ts) "post\n"
		set res [getresp $news($ts)]
		if { [rescode $res 340] } {
		} else {
			socksend $news($ts) "From: $news($w,1)\n"
			socksend $news($ts) "Newsgroups: $news($w,2)\n"
			socksend $news($ts) "Date: $news($w,3)\n"
			socksend $news($ts) "Subject: $news($w,4)\n"
			socksend $news($ts) "\n"

			foreach line [split [$w.main get 1.0 end] "\n"] {
				if { $line == "." } {
					set line ".."
				}
				socksend $news($ts) "$line\n"
			}

			if { [file readable $news($w,5)] } {
				set fd [open $news($w,5) r]
				socksend $news($ts) "-------------   Attachment ($news($w,5)) -------------\n"
				while { [gets $fd line] >= 0 } {
					if { $line == "." } {
						set line ".."
					}
					socksend $news($ts) "$line\n"
				}
				close $fd
			}
			
			if { $news(sig) != "" } {
				socksend $news($ts) "$news(sig)\n"
			}
			socksend $news($ts) "\n.\n"
			rescode [getresp $news($ts)] 240
		}
		disconnect $news($ts)
	}
	closewin $ts
}

#  Post an article to a news group
#  w is only set for a reply
proc mailart { rw g } {
	global news


	set date [gmtime]
	set ts "[lindex [split $date] 1]"

	update
	set w [formwindow $ts mail "Mail"  "To:" "Cc:" "Bcc:" "Subject:" "Date:" "Attachment:"]

	set news($w,1) ""
	set news($w,2) ""
	set news($w,3) ""
	set news($w,4) ""
	set news($w,5) "[string range $date 2 3 ]/[string range $date 4 5 ]/[string range $date 0 1 ]  [string range $date 7 8 ]:[string range $date 9 10 ]:[string range $date 11 12 ] GMT"
	set news($w,6) ""
	#  Handle a reply
	set hesaid ""

	$w.main insert end "\n"; # Create an empty line at the top
	set count 1
	set line [$rw get $count.0 $count.end]
	while { $line != "" } {
		# $w.main insert end ">$line\n"
		set l [split $line : ]
		set hdr [lindex $l 0]
		set bdy [string range $line [expr [string length $hdr] + 1] end] 
		switch $hdr {
			Subject { set news($w,4) [string trim $bdy " "] }
			From    { set from $bdy } 
			Message-ID    { set id $bdy } 
		}
	incr count
	set line [$rw get $count.0 $count.end]
	}

	
	set hesaid [$rw get $count.0 end]
	$w.main insert end "in message $id from $g\n$from wrote:\n"
	foreach line [split $hesaid "\n"] {
		$w.main insert end ">$line\n"
	}

	$w.ok configure -command "set news($w,wait) 1"
	$w.cancel configure -command "set news($w,wait) 2"
	bind $w.uf.f6.e  <Tab> "focus $w.main;break"
	focus $w.uf.f1.e 

	set news($w,wait) 0

set ok 0
while { ! $ok } {
	tkwait variable news($w,wait)
	if { $news($w,wait) == 1 } {

		set news($ts) [socket]
		connect $news($ts) $news(mail) smtp

		# Check for a good connection
		set res [getresp $news($ts)]
		if { [rescode $res 220] } {
			disconnect $news($ts)
			closewin $ts
			return ""
		}
		set domain [lindex [split $news(email) @] 1]
		socksend $news($ts) "helo $domain\n"
		set res [getresp $news($ts)]
		if { [rescode $res 250] } {
			disconnect $news($ts)
			closewin $ts
			return ""
		}

		socksend $news($ts) "mail FROM:<$news(email)>\n"
		if { [rescode [getresp $news($ts)] 250 ]} {
			disconnect $news($ts)
			closewin $ts
			return ""
		}

		set rok 1
		foreach var [list $news($w,1) $news($w,2) $news($w,3)] {
		foreach rcpt [split $var ","] {
			socksend $news($ts) "rcpt TO:<$rcpt>\n"
			if { [rescode [getresp $news($ts)] 250 ]} {
				tk_dialog .xxme "TkNews" "$rcpt is not known to $news(mail)" error 0 OK
				set rok 0
			}
		}
		}

		if { $rok } {
			socksend $news($ts) "data\n"
			if { [rescode [getresp $news($ts)] 354] == 0 } {

			socksend $news($ts) "From: $news(name) <$news(email)>\n"
			socksend $news($ts) "To: $news($w,1)\n"
			socksend $news($ts) "Cc: $news($w,2)\n"
			socksend $news($ts) "Subject: $news($w,4)\n"
			socksend $news($ts) "Date: $news($w,5)\n"
			socksend $news($ts) ""

			foreach line [split [$w.main get 1.0 end] "\n"] {
				if { $line == "." } {
					set line ".."
				}
				socksend $news($ts) "$line\n"
			}

			if { [file readable $news($w,6)] } {
				set fd [open $news($w,6) r]
				socksend $news($ts) "-------------   Attachment ($news($w,6)) -------------\n"
				while { [gets $fd line] >= 0 } {
					if { $line == "." } {
						set line ".."
					}
					socksend $news($ts) "$line\n"
				}
				close $fd
			}
			
			if { $news(sig) != "" } {
				socksend $news($ts) "$news(sig)\n"
			}
			socksend $news($ts) "\n.\n"
			if { [rescode [getresp $news($ts)] 250] == 0 } {
				set ok 1
			}
			disconnect $news($ts)
			}
		}
	} else {
		set ok 1 ; # Cancel
	}
	}
	closewin $ts
}





######   Code starts here   #######################

if { [info exists env(SYSTEMROOT)] } {
	# This is MS-Windows
	set news(wish) wish41
	set news(rm)   del
	load c:/tcldll/tclsock.dll socket
	load c:/tcldll/tcluucod.dll uucode
} else {
	set news(wish) wish4.1
	set news(rm)   rm
	load ./tclsock.so socket
	load ./tcluucod.so uucode
}


if { ![info exists env(TKNEWS)] } {
	set news(home) [pwd]
} else {
	set news(home) $env(TKNEWS)
}

set news(main) ""


if { ![file exists $news(home) ] } {

	if { [tk_dialog .newsdialog "TkNews" "$news(home) does note exists.\nCreate it now?" question 0 OK CANCEL ] == 1 } {
		exit 1
	} else {
		if [catch {exec mkdir $news(home)} msg ] {
			tk_dialog .newsdialog "TkNews" "Can't create $news(home); ($msg)" error 0 OK
			exit 1
		}
	}
}

if { [file exists $news(home)/tknews.geo] } {
	source $news(home)/tknews.geo
}

set news(.news,message) "TkNews: Initialization"
set news(sort) Subject
set news(saveonexit) 1
set news(filename) ""
#  Create the application main window
window .news TkNews TkNews listbox Stop Exit Subscribe UnSubscribe Connect Filter catchup

.news.stop configure -command "set news(.news,stop) 1"
.news.exit configure -command "leave 1"
.news.subscribe configure -command "subscribe_to"
.news.unsubscribe configure -command "unsubscribe"
.news.connect configure -command "connect_server"
.news.filter configure -command "refilter"
.news.catchup configure -command "catchup1 " -text "Catch Up"


menubutton .news.uf.m3 -text File -relief raised -menu .news.uf.m3.m
set m [menu  .news.uf.m3.m -tearoff 1]
$m add command -label "Get New Groups" -command getnewgroups
$m add command -label "Download All Groups" -command getallgroups
$m add command -label "Save" -command "saveConfig 1"
$m add check -label ShowAll -variable news(showall) -command refilter
$m add separator
$m add command -label Quit -command "leave 1"
$m add command -label "Quit Without Saving" -command "leave 0"
pack .news.uf.m3 -in .news.uf -anchor nw -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
#------------------------------------------

menubutton .news.uf.m4 -text Options -menu .news.uf.m4.m -relief raised
set m [menu  .news.uf.m4.m -tearoff 1]
$m add command -label "Setup" -command tknews_setup
$m add check -label "Connect on startup" -variable news(con_on_start)
$m add cascade -label "Sort By" -menu $m.mc1
set m2 [menu $m.mc1 -tearoff 0]
$m2 add radio -label "Subject" -variable news(sort)
$m2 add radio -label "Date" -variable news(sort)
$m2 add radio -label "Auther" -variable news(sort)
$m add check -label "Get New Groups on Startup" -variable news(newgrps)
$m add check -label "Save Setup on Exit" -variable news(saveonexit)
pack .news.uf.m4 -in .news.uf -anchor nw -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

set news(glst) .news.main
bind $news(glst) <Double-1> { read_group }





loadConfig

if { [info exists env(NNTPSERVER)] } {
	set news(serv) $env(NNTPSERVER); # This can override
}

if { $news(con_on_start) } {
	connect_server
}

#set w [window  .tst Test text Quit connect Write Read Cancel]
#$w.quit configure -command "exit 0"
#$w.write configure -command {
#		socksend $sock "helo infinet.com\n"
#	$w.main insert end "send $sock done\n"
#		}
#$w.connect configure -command {
#		set res [connect $sock mail smtp]
#		$w.main insert end "connct ($res)"
#		}
#
#$w.read configure -command { 
#		set res [recv $sock]
#		puts "Done with read ($res)"
#		$w.main insert end "$res\n"
#		$w.main insert end "recv $sock done\n"
#		}
#$w.cancel configure -command {
#		cancelsocket $sock
#		$w.main insert end "$sock canceled\n"
#		}
#
#set sock [socket]
#update
#
#$w.main insert end "[recv $sock]\n"
#$w.main insert end "recv $sock done\n"
